/* a rexx directory tree -- DT.CMD */

Call RXFUNCADD 'SysFileTree','RexxUtil','SysFileTree'
Call RXFUNCADD 'SysDriveInfo','RexxUtil','SysDriveInfo'

PARSE UPPER ARG COMMANDS

say 'c:\'
call List 'c:\' 1 0
exit

List: procedure
arg Path level last
call SubDirs Path
Parse Var Result NumberOfDirs DirNames
If NumberOfDirs > 0 then
Do I = 1 to NumberOfDirs
   Dir = Word(DirNames, I);
   String=''
   Name = Translate(Dir, ' ', '\');
   Do J = 1 to Level
      If (J=Level-1) & Last then String = String || '    ';
      else If J<Level then String = String || '3   '
      else If ((J=Level) & (I<>NumberOfDirs))
         then String = String || 'A'
      else if J=Level then String = String || 'A'
      end;
   String = String || Word(Name, Words(Name));
   Say String
   Call List Dir||'\' level+1 (I=NumberOfDirs)
   end
return

SubDirs:
Parse Arg path
If SysFileTree(Path, Objects, 'DO')<>0
   then Say "Not enough memory to complete request."
else do
   NumberOfDirs = Objects.0;
   Names = '';
   Do I = 1 to NumberOfDirs
      Names = Names Objects.I;
      end
   end
Return NumberOfDirs Names


